/***************************************************************************
 *   Copyright (C) 2003 by Flameeyes                                       *
 *   dgp85@users.sourceforge.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "appletconfig.h"

#include <qlineedit.h>
#include <qcheckbox.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>

#include <kcolorbutton.h>
#include <kdatepicker.h>
#include <kconfig.h>
#include <kglobal.h>

appletconfig::appletconfig(BioritmiApplet *parent)
	: uiAppletConfig(parent, "bioritmi_config")
{
	ksConfig = parent->config();
	load();
}

appletconfig::appletconfig(QWidget *parent, const char* name)
	: uiAppletConfig(parent, name)
{
	ksConfig = KGlobal::config();
	load();
}

appletconfig::~appletconfig()
{
}

void appletconfig::accept()
{
	ksConfig->setGroup("colors");
		ksConfig->writeEntry("emotional", colorEmotional->color());
		ksConfig->writeEntry("intellectual", colorIntellectual->color());
		ksConfig->writeEntry("phisical", colorPhisical->color());

	ksConfig->setGroup("dates");
		ksConfig->writeEntry("birthdate", QDateTime(birthdate->date()));

	ksConfig->setGroup("display");
		ksConfig->writeEntry("ticks", checkTicks->isChecked());
		ksConfig->writeEntry("showEmotional", chkEmotional->isChecked());
		ksConfig->writeEntry("showIntellectual", chkIntellectual->isChecked());
		ksConfig->writeEntry("showPhisical", chkPhisical->isChecked());
		
		if ( reinterpret_cast<QRadioButton*>(graphType->selected()) == radioPoints )
			ksConfig->writeEntry("graphType", 0);
		else if ( reinterpret_cast<QRadioButton*>(graphType->selected()) == radioLine )
			ksConfig->writeEntry("graphType", 1);
		else
			ksConfig->writeEntry("graphType", 0);

	QDialog::accept();
}

void appletconfig::load()
{
	ksConfig->setGroup("colors");
		colorEmotional->setColor(ksConfig->readColorEntry("emotional"));
		colorIntellectual->setColor(ksConfig->readColorEntry("intellectual"));
		colorPhisical->setColor(ksConfig->readColorEntry("phisical"));

	ksConfig->setGroup("dates");
		QDateTime dt( QDate(1985, 11, 28) );
		birthdate->setDate(ksConfig->readDateTimeEntry("birthdate", &dt).date());

	ksConfig->setGroup("display");
		checkTicks->setChecked(ksConfig->readBoolEntry("ticks"));
		chkEmotional->setChecked(ksConfig->readBoolEntry("showEmotional"));
		chkIntellectual->setChecked(ksConfig->readBoolEntry("showIntellectual"));
		chkPhisical->setChecked(ksConfig->readBoolEntry("showPhisical"));
		
		switch(ksConfig->readNumEntry("graphType", 0))
		{
			case 1:
				radioLine->setChecked(true); break;
			default:
				radioPoints->setChecked(true); break;
		}
}

#include "appletconfig.moc"
